





local gI = {}
local gS = {}
local ghandle = 0

local function Newid()
	ghandle = ghandle-1
	return ghandle
end



local IMBIRMETA = {
	__newindex = function(self,Cname,Cprop)
		local compT = gI[self._id]
		compT[Cname] = Cprop
	end,
	__index = function(self,Cname)
		return gI[self._id][Cname]
	end
	}
		
function Imbir(compT)
	local aux = {_id = Newid()}
	gI[aux._id] = compT or {}
	setmetatable(aux,IMBIRMETA)
	return aux
end
	

function System(T)
	gS[T._name] = T
	T._name = nil
end

		
local WORLDMETA =  
		{
		__add = function(self,Imbir)
				self[Imbir._id] = Imbir
				return self
			end,
		__sub = function(self,Imbir)
				self[Imbir._id] = nil
				return self
			end,
		__call = function(self,T)
				for i,system in ipairs(T) do
					local sys = gS[system]
					if not sys then error('No system named "'..system..'"') end
					
					-- we need to copy all system's imbirs to spare me a headache when inserting/removing imbirs during iteration
					local timbers = {}
					for id,imbir in pairs(self) do
						local flag = true
						for i,comp in ipairs(sys) do
							if not imbir[comp] then
								flag = false
								break
							end
						end
						if flag then
							table.insert(timbers,imbir)
						end
					end
					
					-- shiver my timbers
					for i,imbir in ipairs(timbers) do
						sys.Logic(imbir)
					end
				end
			end
		}
		
function World() -- MAX priority table
	local aux = {}
	setmetatable(aux,WORLDMETA)
	
	return aux
end
	



	


