

require 'imbir5'
floor = math.floor
getmetatable('').__index = function(s,i) return string.sub(s,i,i) end

border = {
	'#########################################################',
	'#.......................................................#',
	'#.......................................................#',
	'#.......................................................#',
	'#.......................................................#',
	'#.......................................................#',
	'.........................................................',
	'.........................................................',
	'.........................................................',
	'.........................................................',
	'.........................................................',
	'.........................................................',
	'.........................................................',
	'.........................................................',
	'#.......................................................#',
	'#.......................................................#',
	'#.......................................................#',
	'#.......................................................#',
	'#.......................................................#',
	'#########################################################',
	}
	
setmetatable(border, {__index = function() return '' end})
function BORDER(x,y) return border[y+1][x+1] end
READYPC = 1
READYENEMY = 2
MOVINGTOPC = 3
MOVINGTOENEMY = 4
GOALFORPC = 5
GOALFORENEMY = 6

R = 5
S = 7
rpx = 5
rpy = 30
SCORE = {0,0}


function Reset()
	STATE = READYPC
	X = World()
	
	ppal = Imbir{position = {x=760,y=300}}
	epal = Imbir{position = {x=40,y=300}}
	ball = Imbir{velocity = {x=0,y=0}, position = {x = ppal.position.x-R*2,y=300}}

	X = X + ball
end
Reset()

function sgn(x) return x>0 and 1 or -1 end

System{
	_name = 'checkCollisions',
	
	'velocity',
	'position',
	
	Logic = function(a)
		local nx,ny = a.position.x+a.velocity.x, a.position.y+a.velocity.y
		local bx,by = (nx+sgn(a.velocity.x)*R), (ny+sgn(a.velocity.y)*R)
		
		if math.abs(nx - ppal.position.x) < R+rpx and
			math.abs(ny - ppal.position.y) < R+rpy then
				angle = math.abs(ny-ppal.position.y)/rpy
				angle = math.max(0.2,math.min(0.8,angle))
				a.velocity.x = -(1-angle)
				a.velocity.y = sgn(a.velocity.y)*angle
		elseif 		math.abs(nx - epal.position.x) < R+rpx and
					math.abs(ny - epal.position.y) < R+rpy then
				angle = math.abs(ny-epal.position.y)/rpy
				angle = math.max(0.2,math.min(0.8,angle))
				a.velocity.x = 1-angle
				a.velocity.y = sgn(a.velocity.y)*angle
		elseif BORDER(floor(a.position.x/w), floor(by/h)) == '#' then
				a.velocity.y = -a.velocity.y
		end
		if BORDER(floor(bx/w), floor(a.position.y/h)) == '#' then
				a.velocity.x = -a.velocity.x
		end
		if nx < 0 then
			SCORE[2] = SCORE[2]+1
			Reset()
		elseif nx > 800 then
			SCORE[1] = SCORE[1]+1
			Reset()
		end
	end
	}
System{
	_name = 'doCollisions',
	
	'collision',
	
	Logic = function(a)
		a.velocity.x = -a.velocity.x
		a.velocity.y = -a.velocity.y
		a.collision = nil
	end
	}
System{
	_name = 'doVelocity',
	
	'velocity',
	'position',
	
	Logic = function(a)
		a.position.x = a.position.x + a.velocity.x*S
		a.position.y = a.position.y + a.velocity.y*S
	end
	}

	
W = #border[1]
H = #border
w = floor(800/W)
h = floor(600/H)


	
FPS = 60
f = 0
t = 0
fps = 1/60
time = 0
function love.update(dt)
	time = time+dt
	while time > fps do
		time = time-fps
		
		f = f+1
		
		if KEY == 'down' then
			ppal.position.y = math.min(ppal.position.y + 5, 550)
			if STATE == READYPC then
				ball.velocity.x = -0.5
				ball.velocity.y = 0.5
				STATE = MOVINGTOENEMY
			end
		elseif KEY == 'up' then
			ppal.position.y = math.max(ppal.position.y - 5, 50)
			if STATE == READYPC then
				ball.velocity.x = -0.5
				ball.velocity.y = -0.5
				STATE = MOVINGTOENEMY
			end
		end
		
		if ball.position.y > epal.position.y then
			epal.position.y = epal.position.y + S*0.3
		elseif ball.position.y < epal.position.y then
			epal.position.y = epal.position.y - S*0.3
		end
		
		X{'checkCollisions','doCollisions','doVelocity'}
	end
	KEY = ''
	
	t = t+dt
	if t > 1 then
		FPS = f
		f = 0
		t = t-1
	end
end


function love.draw()
	for y=0,H-1 do
		for x=0,W-1 do
			if BORDER(x,y) == '#' then
				love.graphics.rectangle('fill',(x)*w,(y)*h,w,h)
			end
			
			love.graphics.rectangle('fill',ppal.position.x-rpx, ppal.position.y-rpy, rpx*2,rpy*2)
			love.graphics.rectangle('fill',epal.position.x-rpx, epal.position.y-rpy, rpx*2,rpy*2)
			love.graphics.rectangle('fill',ball.position.x-R, ball.position.y-R, R*2,R*2)
			
			love.graphics.print(SCORE[1]..' : '..SCORE[2]..' fps:'..FPS, 390,100)
		end
	end
end


love.keyboard.setKeyRepeat(fps*2,fps*2)
function love.keypressed(key)
	if key=='down' then 
		KEY = 'down'
	elseif key=='up' then 
		KEY = 'up'
    elseif key == 'escape' then
        love.event.push('quit') -- Quit the game.
    end 
end

